Blame SOURCES/check_caveats

c59b13
#! /bin/bash -eu
c59b13
c59b13
# Script for checking various microcode caveats
c59b13
#
c59b13
#
c59b13
# SPDX-License-Identifier: CC0-1.0
c59b13
c59b13
: ${MC_CAVEATS_DATA_DIR=/usr/share/microcode_ctl/ucode_with_caveats}
c59b13
: ${FW_DIR=/lib/firmware}
c59b13
: ${CFG_DIR=/etc/microcode_ctl/ucode_with_caveats}
c59b13
fe8809
MAX_NESTING_LEVEL=8
fe8809
c59b13
usage() {
078ac8
	echo 'Usage: check_caveats [-d] [-e] [-k TARGET_KVER] [-c CONFIG]'
078ac8
	echo '                     [-m] [-v]'
c59b13
	echo
078ac8
	echo '   -d - enables disclaimer printing mode'
c59b13
	echo '   -e - check for early microcode load possibility (instead of'
c59b13
	echo '        late microcode load)'
c59b13
	echo '   -k - target version to check against, $(uname -r) is used'
c59b13
	echo '        otherwise'
c59b13
	echo '   -c - caveat config(s) to check, all configs are checked'
c59b13
	echo '        otherwise'
c59b13
	echo '   -m - check that caveats actually apply to the current model'
c59b13
	echo '   -v - verbose output'
c59b13
	echo
c59b13
	echo 'Environment:'
c59b13
	echo '  MC_CAVEATS_DATA_DIR - directory that contains caveats'
c59b13
	echo '                        configuration data'
c59b13
}
c59b13
c59b13
debug() { [ 0 = "$verbose" ] || echo "$*" >&2; }
c59b13
c59b13
# A simplified RPM version comparison that takes into account knowledge about
c59b13
# Y- and Z-streams (so it compares versions inside Y-stram or Z-stream if
c59b13
# the version against which comparison is performed has appropriate versioning
c59b13
# scheme).
c59b13
#
c59b13
# $1 - kernel version to check
c59b13
# $* - list of kernel versions to check against
c59b13
check_kver()
c59b13
{
c59b13
	local t_major= t_minor= t_patch= t_y= t_z1= t_z2= t_rest=
c59b13
	local m_major= m_minor= m_patch= m_y= m_z1= m_z2= m_rest=
c59b13
	local cmp_type=
c59b13
c59b13
	# IFS=.- read -r t_major t_minor t_patch t_y t_z1 t_z2 t_rest <<<"$1"
c59b13
	# "cannot create temp file for here-document: Read-only file system"
c59b13
	# that's why we can't have nice things.
c59b13
	t_major=${1%%.*}
c59b13
	t_rest=${1#${t_major}}
c59b13
	t_rest=${t_rest#.}
c59b13
	t_minor=${t_rest%%.*}
c59b13
	t_rest=${t_rest#${t_minor}}
c59b13
	t_rest=${t_rest#.}
c59b13
	t_patch=${t_rest%%-*}
c59b13
	t_rest=${t_rest#${t_patch}}
c59b13
	t_rest=${t_rest#-}
c59b13
	t_y=${t_rest%%.*}
c59b13
	t_rest=${t_rest#${t_y}}
c59b13
	t_rest=${t_rest#.}
c59b13
	t_z1=${t_rest%%.*}
c59b13
	t_rest=${t_rest#${t_z1}}
c59b13
	t_rest=${t_rest#.}
c59b13
	t_z2=${t_rest%%.*}
c59b13
c59b13
	# minor/major/patch/y should be numeric
c59b13
	[ -n "${t_major##*[!0-9]*}" ] || return 1
c59b13
	[ -n "${t_minor##*[!0-9]*}" ] || return 1
c59b13
	[ -n "${t_patch##*[!0-9]*}" ] || return 1
c59b13
	[ -n "${t_y##*[!0-9]*}" ] || return 1
c59b13
	# reset z1/z2 to zero if non-numeric
c59b13
	[ -n "${t_z1##*[!0-9]*}" ] || t_z1=0
c59b13
	[ -n "${t_z2##*[!0-9]*}" ] || t_z2=0
c59b13
c59b13
	while [ 1 -lt "$#" ]; do
c59b13
		cmp_type=upstream
c59b13
c59b13
		shift
c59b13
		m_major=${1%%.*}
c59b13
		m_rest=${1#${m_major}}
c59b13
		m_rest=${m_rest#.}
c59b13
		m_minor=${m_rest%%.*}
c59b13
		m_rest=${m_rest#${m_minor}}
c59b13
		m_rest=${m_rest#.}
c59b13
		m_patch=${m_rest%%-*}
c59b13
		m_rest=${m_rest#${m_patch}}
c59b13
		m_rest=${m_rest#-}
c59b13
		m_y=${m_rest%%.*}
c59b13
		m_rest=${m_rest#${m_y}}
c59b13
		m_rest=${m_rest#.}
c59b13
		m_z1=${m_rest%%.*}
c59b13
		m_rest=${m_rest#${m_z1}}
c59b13
		m_rest=${m_rest#.}
c59b13
		m_z2=${m_rest%%.*}
c59b13
c59b13
		# minor/major/patch should be numeric
c59b13
		[ -n "${m_major##*[!0-9]*}" ] || continue
c59b13
		[ -n "${m_minor##*[!0-9]*}" ] || continue
c59b13
		[ -n "${m_patch##*[!0-9]*}" ] || continue
c59b13
		# reset z1/z2 to zero if non-numeric
c59b13
		[ -n "${m_y##*[!0-9]*}" ] && cmp_type=y || m_y=0
c59b13
		[ -n "${m_z1##*[!0-9]*}" ] && cmp_type=z || m_z1=0
c59b13
		[ -n "${m_z2##*[!0-9]*}" ] && cmp_type=z || m_z2=0
c59b13
c59b13
		# Comparing versions
c59b13
		case "$cmp_type" in
c59b13
		upstream)
c59b13
			[ "$t_major" -ge "$m_major" ] || continue
c59b13
			[ "$t_minor" -ge "$m_minor" ] || continue
c59b13
			[ "$t_patch" -ge "$m_patch" ] || continue
c59b13
			return 0
c59b13
			;;
c59b13
		y)
c59b13
			[ "$t_major" -eq "$m_major" ] || continue
c59b13
			[ "$t_minor" -eq "$m_minor" ] || continue
c59b13
			[ "$t_patch" -eq "$m_patch" ] || continue
c59b13
			[ "$t_y" -ge "$m_y" ] || continue
c59b13
			return 0
c59b13
			;;
c59b13
		z)
c59b13
			[ "$t_major" -eq "$m_major" ] || continue
c59b13
			[ "$t_minor" -eq "$m_minor" ] || continue
c59b13
			[ "$t_patch" -eq "$m_patch" ] || continue
c59b13
			[ "$t_y" -eq "$m_y" ] || continue
c59b13
			[ "$t_z1" -ge "$m_z1" ] || continue
c59b13
			[ "$t_z2" -ge "$m_z2" ] || continue
c59b13
			return 0
c59b13
			;;
c59b13
		esac
c59b13
	done
c59b13
c59b13
	return 1
c59b13
}
c59b13
81200a
# It is needed for SKX[1] for which different product segments
81200a
# are differentiated by a value in the CAPID0 field of PCU registers
81200a
# device[2].
81200a
# [1] https://github.com/intel/Intel-Linux-Processor-Microcode-Data-Files/issues/21
81200a
# [2] https://www.intel.com/content/dam/www/public/us/en/documents/specification-updates/xeon-scalable-spec-update.pdf#page=13
81200a
#
81200a
# $1 - params in config file, space-separated, in key=value form:
81200a
#   domain=* - PCI domain, '*' or number
81200a
#   bus=* - PCI bus, '*' or number
81200a
#   device=* - PCI device, '*' or number
81200a
#   function=* - PCI function, '*' or number
81200a
#   vid= - PCI vendor ID, empty or number
81200a
#   did= - PCI device ID, empty or number
81200a
#   offset=0 - offset in configuration space
81200a
#   size=4 - field size
81200a
#   mask=0 - mask applied to the data read
81200a
#   val=0 - comma-separated list of possible values
81200a
#   mode=success-any [ success-ail, fail-any, fail-all ] - matching mode:
81200a
#     success-any: Returns 0 if there was at least one match, otherwise 1.
81200a
#     success-all: Returns 0 if there was at least one device checked and all
81200a
#                  the checked devices have matches, otherwise 1.
81200a
#     fail-any:    Returns 1 if there was at least one match, otherwise 0.
81200a
#     fail-all:    Returns 1 if there was at least one device checked and all
81200a
#                  the checked devices have matches, otherwise 0.
81200a
# $2 - whether model filter is engaged (if it is not '1', just return the result
81200a
#      based on "mode" value that assumes that there were 0 checks/0 matches).
81200a
check_pci_config_val()
81200a
{
81200a
	local domain='*' bus='*' device='*' func='*' vid= did=
81200a
	local offset=0 size=4 mask=0 val=0 mode=success-any
81200a
	local checked=0 matched=0 path=''
81200a
	local dev_path dev_vid dev_did dev_val
81200a
	local opts="${1:-}"
fe8809
	local match_model="${2:-0}"
81200a
81200a
	set -- $1
81200a
	while [ "$#" -gt 0 ]; do
81200a
		[ "x${1#domain=}" = "x${1}" ] || domain="${1#domain=}"
81200a
		[ "x${1#bus=}" = "x${1}" ] || bus="${1#bus=}"
81200a
		[ "x${1#device=}" = "x${1}" ] || device="${1#device=}"
81200a
		[ "x${1#function=}" = "x${1}" ] || func="${1#function=}"
81200a
		[ "x${1#vid=}" = "x${1}" ] || vid="${1#vid=}"
81200a
		[ "x${1#did=}" = "x${1}" ] || did="${1#did=}"
81200a
		[ "x${1#offset=}" = "x${1}" ] || offset="${1#offset=}"
81200a
		[ "x${1#size=}" = "x${1}" ] || size="${1#size=}"
81200a
		[ "x${1#mask=}" = "x${1}" ] || mask="${1#mask=}"
81200a
		[ "x${1#val=}" = "x${1}" ] || val="${1#val=}"
81200a
		[ "x${1#mode=}" = "x${1}" ] || mode="${1#mode=}"
81200a
81200a
		shift
81200a
	done
81200a
81200a
	path="$domain"
81200a
	if [ "x$bus" = 'x*' ]; then
81200a
		path="$path:$bus";
81200a
	else
81200a
		path=$(printf '%s:%02x' "$path" "$bus")
81200a
	fi
81200a
	if [ "x$device" = 'x*' ]; then
81200a
		path="$path:$device";
81200a
	else
81200a
		path=$(printf '%s:%02x' "$path" "$device")
81200a
	fi
81200a
	if [ "x$func" = 'x*' ]; then
81200a
		path="$path.$func";
81200a
	else
81200a
		path=$(printf '%s.%01x' "$path" "$func")
81200a
	fi
81200a
81200a
	# Normalise VID, DID
81200a
	[ -n "$vid" ] || vid="$(printf '0x%04x' "$vid")"
81200a
	[ -n "$did" ] || did="$(printf '0x%04x' "$did")"
81200a
81200a
	( [ 1 != "$match_model" ] \
81200a
	  || /usr/bin/find /sys/bus/pci/devices/ -maxdepth 1 -name "$path" \
81200a
	  || : ) | (
81200a
		while read -r dev_path; do
81200a
			# Filter VID, DID
81200a
			if [ -n "$vid" ]; then
81200a
				dev_vid=$(/bin/cat "$dev_path/vendor")
81200a
				[ "x$vid" = "x$dev_vid" ] || continue
81200a
			fi
81200a
			if [ -n "$did" ]; then
81200a
				dev_did=$(/bin/cat "$dev_path/device")
81200a
				[ "x$did" = "x$dev_did" ] || continue
81200a
			fi
81200a
81200a
			checked="$((checked + 1))"
81200a
81200a
			dev_val="$(/usr/bin/od -j "$offset" -N "$size" -A n \
81200a
					       -t "u$size" "$dev_path/config")"
81200a
81200a
			val_rest="${val}"
81200a
			while :; do
81200a
				cur_val="${val_rest%%,*}"
81200a
				if [ "$((dev_val & mask))" = "$((cur_val & mask))" ]
81200a
				then
81200a
					matched="$((matched + 1))"
81200a
					break
81200a
				fi
81200a
				[ "x${val_rest}" != "x${val_rest#*,}" ] || break
81200a
				val_rest="${val_rest#*,}"
81200a
			done
81200a
81200a
			case "$mode" in
81200a
			success-any) [ "$matched" -eq 0 ] || { echo 0; exit; } ;;
81200a
			success-all) [ "$matched" -eq "$checked" ] || { echo 1; exit; } ;;
81200a
			fail-any)    [ "$matched" -eq 0 ] || { echo 1; exit; } ;;
81200a
			fail-all)    [ "$matched" -eq "$checked" ] || { echo 0; exit; } ;;
81200a
			*)           echo 2; exit;;
81200a
			esac
81200a
		done
81200a
81200a
		debug "PCI config value check ($opts): checked $checked," \
81200a
		      "matched $matched (model check is set to $match_model)"
81200a
81200a
		case "$mode" in
81200a
		success-any) if [ "$matched" -eq 0 ]; then echo 1; else echo 0; fi ;;
81200a
		success-all) if [ "$matched" -gt 0 -a "$matched" -eq "$checked" ]; then echo 0; else echo 1; fi ;;
81200a
		fail-any)    if [ "$matched" -eq 0 ]; then echo 0; else echo 1; fi  ;;
81200a
		fail-all)    if [ "$matched" -gt 0 -a "$matched" -eq "$checked" ]; then echo 1; else echo 0; fi ;;
81200a
		*)           echo 2; exit;;
81200a
		esac
81200a
	)
81200a
}
81200a
81200a
# It is needed for filtering by BIOS vendor name that is available in DMI data
81200a
#
81200a
# $1 - params in config file, space-separated, in key=value form:
fe8809
#   key= - DMI data record to check. Can be one of the following: bios_date,
81200a
#          bios_vendor, bios_version, board_asset_tag, board_name, board_serial,
81200a
#          board_vendor, board_version, chassis_asset_tag, chassis_serial,
81200a
#          chassis_type, chassis_vendor, chassis_version, product_family,
81200a
#          product_name, product_serial, product_uuid, product_version,
81200a
#          sys_vendor.
81200a
#   val= - a string to match DMI data against.  Can be enclosed in single
81200a
#          or double quotes.
fe8809
#   keyval= - a string of format "KEY(!)?[=:]VAL" (so, one of "KEY=VAL",
fe8809
#             "KEY!=VAL", "KEY:VAL", "KEY!:VAL") that allows providing
fe8809
#             a key-value pair in a single parameter.  It is possible to provide
fe8809
#             multiple keyval= parameters.  "!" before :/= means negated match.
fe8809
#             The action supplied in the mode= parameter is executed upon
fe8809
#             successful (non-)matching of all the keyval pairs (as well
fe8809
#             as the pair provided in a pair of key= and val= parameters).
81200a
#   mode=success-equal [ success-equal, fail-equal ] - matching mode:
fe8809
#     success-equal: Returns 0 if the all values present in the corresponding
fe8809
#                    files under /sys/devices/virtual/dmi/id/<KEY> are equal
fe8809
#                    (or not equal in case of a keyval= with negated match)
fe8809
#                    to the respective values supplied as the values
fe8809
#                    of the keyval= parameters or the pair of key= vand val=
fe8809
#                    parameters, otherwise 1.
fe8809
#     fail-equal:    Returns 1 if all the values present in DMI files in sysfs
fe8809
#                    match (as described above), otherwise 0.
81200a
#   no-model-mode=success [ success, fail ] - return value if model filter
81200a
#                                             is not enabled:
81200a
#     success: Return 0.
81200a
#     fail:    Return 1.
81200a
# $2 - whether model filter is engaged (if it is not '1', just return the result
fe8809
#      based on "no-model-mode" value).
81200a
check_dmi_val()
81200a
{
fe8809
	local key= val= keyval= keyvals= mode='success-equal' nm_mode='success'
81200a
	local opts="${1:-}" opt= opt_=
fe8809
	local match_model="${2:-0}"
81200a
81200a
	local valid_keys=" bios_date bios_vendor bios_version board_asset_tag board_name board_serial board_vendor board_version chassis_asset_tag chassis_serial chassis_type chassis_vendor chassis_version product_family product_name product_serial product_uuid product_version sys_vendor "
81200a
	local success=1
81200a
81200a
	while [ -n "$opts" ]; do
81200a
		opt="${opts%%[ 	]*}"
81200a
		[ -n "${opt}" ] || { opts="${opts#[ 	]}"; continue; }
81200a
81200a
		[ "x${opt#key=}" = "x${opt}" ] || key="${opt#key=}"
81200a
		[ "x${opt#mode=}" = "x${opt}" ] || mode="${opt#mode=}"
81200a
		[ "x${opt#no-model-mode=}" = "x${opt}" ] || \
81200a
			nm_mode="${opt#no-model-mode=}"
81200a
81200a
		# Handle possible quoting
81200a
		[ "x${opt#val=}" = "x${opt}" ] || {
81200a
			case "${opt#val=}" in
fe8809
			[\']*) opt_="${opts#val=\'}"; val="${opt_%%\'*}"; opt="val='${val}'" ;;
fe8809
			[\"]*) opt_="${opts#val=\"}"; val="${opt_%%\"*}"; opt="val=\"${val}\"" ;;
81200a
			*)    val="${opt#val=}" ;;
81200a
			esac
81200a
		}
fe8809
		[ "x${opt#keyval=}" = "x${opt}" ] || {
fe8809
			case "${opt#keyval=}" in
fe8809
			[\']*)
fe8809
				opt_="${opts#keyval=\'}"
fe8809
				keyval="${opt_%%\'*}"
fe8809
				opt="keyval='${keyval}'"
fe8809
				keyvals="${keyvals}
fe8809
					${keyval}"
fe8809
				;;
fe8809
			[\"]*)
fe8809
				opt_="${opts#keyval=\"}"
fe8809
				keyval="${opt_%%\"*}"
fe8809
				opt="keyval=\"${keyval}\""
fe8809
				keyvals="${keyvals}
fe8809
					${keyval}"
fe8809
				;;
fe8809
			*)
fe8809
				keyvals="${keyvals}
fe8809
					${opt#keyval=}"
fe8809
				;;
fe8809
			esac
fe8809
		}
81200a
81200a
		opts="${opts#"${opt}"}"
81200a
		continue
81200a
	done
81200a
fe8809
	[ -z "$key" -a -z "$val" ] || keyvals="${key}=${val}${keyvals}"
fe8809
fe8809
	[ -n "x${keyvals}" ] || {
fe8809
		debug "Neither key=, val=, nor keyval= parameters were privoded"
81200a
		echo 2
fe8809
		return
81200a
	}
81200a
81200a
	[ 1 = "$match_model" ] || {
81200a
		case "$nm_mode" in
81200a
		success) echo 0 ;;
81200a
		fail)    echo 1 ;;
81200a
		*)
81200a
			debug "Invalid no-model-mode value: \"${nm_mode}\""
81200a
			echo 2
81200a
			;;
81200a
		esac
81200a
fe8809
		return
81200a
	}
81200a
fe8809
	case "$mode" in
fe8809
	success-equal|fail-equal) ;;
fe8809
	*) debug "Invalid mode value: \"${nm_mode}\""; echo 2; return ;;
fe8809
	esac
81200a
fe8809
	printf "%s\n" "${keyvals}" | (
fe8809
		while read l; do
fe8809
			[ -n "$l" ] || continue
fe8809
			key="${l%%[=:]*}"
fe8809
			val="${l#${key}[=:]}"
fe8809
fe8809
			cmp="="
fe8809
			[ "x${key%!}" = "x${key}" ] || {
fe8809
				cmp="!="
fe8809
				key="${key%!}"
fe8809
			}
fe8809
fe8809
			# Check key for validity
fe8809
			[ "x${valid_keys#* ${key} *}" != "x${valid_keys}" ] || {
fe8809
				debug "Invalid \"key\" parameter value: \"${key}\""
fe8809
				echo 2
fe8809
				return
fe8809
			}
fe8809
fe8809
			[ -r "/sys/devices/virtual/dmi/id/${key}" ] || {
fe8809
				debug "Can't access /sys/devices/virtual/dmi/id/${key}"
fe8809
				echo 3
fe8809
				return
fe8809
			}
fe8809
fe8809
			file_val="$(/bin/cat "/sys/devices/virtual/dmi/id/${key}")"
fe8809
fe8809
			[ "x${val}" "${cmp}" "x${file_val}" ] || {
fe8809
				case "$mode" in
fe8809
				success-equal) echo 1 ;;
fe8809
				fail-equal)    echo 0 ;;
fe8809
				esac
fe8809
fe8809
				return
fe8809
			}
fe8809
		done
81200a
fe8809
		case "$mode" in
fe8809
		success-equal) echo 0 ;;
fe8809
		fail-equal)    echo 1 ;;
fe8809
		esac
fe8809
	)
fe8809
}
81200a
fe8809
# check_dependency CURLEVEL DEP_TYPE DEP_NAME OPTS
fe8809
# DEP_TYPE:
fe8809
#   required - caveat can be enabled only if dependency is enabled
fe8809
#              (is not forcefully disabled and meets caveat conditions)
fe8809
# OPTS:
fe8809
#   match-model-mode=same [ on, off, same ] - what mode matching mode is to be used for dependency
fe8809
#   skip=skip [ fail, skip, success ]
fe8809
#   force-skip=skip [ fail, skip, success ]
fe8809
#   nesting-too-deep=fail [ fail, skip, success ]
fe8809
# Return values:
fe8809
#   0 - success
fe8809
#   1 - fail
fe8809
#   2 - skip
fe8809
#   9 - error
fe8809
check_dependency()
fe8809
{
fe8809
	local cur_level="$1"
fe8809
	local dep_type="$2"
fe8809
	local dep_name="$3"
fe8809
	local match_model_mode=same old_match_model="${match_model}"
fe8809
	local skip=skip
fe8809
	local force_skip=skip
fe8809
	local nesting_too_deep=fail
fe8809
fe8809
	local check="Dependency check for ${dep_type} ${dep_name}"
fe8809
fe8809
	set -- ${4:-}
fe8809
	while [ "$#" -gt 0 ]; do
fe8809
		[ "x${1#match-model-mode=}" = "x${1}" ] || match_model_mode="${1#match-model-mode=}"
fe8809
		[ "x${1#skip=}" = "x${1}" ] || skip="${1#skip=}"
fe8809
		[ "x${1#force-skip=}" = "x${1}" ] || force_skip="${1#force-skip=}"
fe8809
		[ "x${1#nesting-too-deep=}" = "x${1}" ] || nesting_too_deep="${1#nesting-too-deep=}"
fe8809
fe8809
		shift
fe8809
	done
fe8809
fe8809
	case "${dep_type}" in
fe8809
	required)
fe8809
		[ "x${dep_name%/*}" = "x${dep_name}" ] || {
fe8809
			debug "${check} error: dependency name (${dep_name})" \
fe8809
			      "cannot contain slashes"
fe8809
			echo 9
fe8809
			return
fe8809
		}
fe8809
fe8809
		[ "${MAX_NESTING_LEVEL}" -ge "$cur_level" ] || {
fe8809
			local reason="nesting level is too deep (${cur_level}) and nesting-too-deep='${nesting_too_deep}'"
fe8809
fe8809
			case "$nesting_too_deep" in
fe8809
			success) debug "${check} succeeded: ${reason}"; echo 0 ;;
fe8809
			fail)    debug "${check} failed: ${reason}"; echo 1 ;;
fe8809
			skip)    debug "${check} skipped: ${reason}"; echo 2 ;;
fe8809
			*)       debug "${check} error: invalid" \
fe8809
				       "nesting-too-deep mode" \
fe8809
				       "(${nesting_too_deep})"; echo 9 ;;
fe8809
			esac
fe8809
fe8809
			return
fe8809
		}
fe8809
fe8809
		case "${match_model_mode}" in
fe8809
		same) ;;
fe8809
		on)   match_model=1 ;;
fe8809
		off)  match_model=0 ;;
fe8809
		*)
fe8809
			debug "${check} error: invalid match-model-mode" \
fe8809
			      "(${match_model_mode})"
fe8809
			echo 9
fe8809
			return
fe8809
			;;
fe8809
		esac
fe8809
fe8809
		local result=0
fe8809
		debug "${check}: calling check_caveat '${dep_name}'" \
fe8809
		      "'$(($cur_level + 1))' match_model=${match_model}"
fe8809
		check_caveat "${dep_name}" "$(($cur_level + 1))" > /dev/null || result="$?"
fe8809
fe8809
		match_model="${old_match_model}"
fe8809
fe8809
		case "${result}" in
fe8809
		0) debug "${check} succeeded: result=${result}"; echo "${result}" ;;
fe8809
		1) debug "${check} failed: result=${result}"; echo "${result}" ;;
fe8809
		2)
fe8809
			local reason="result=${result} and skip='${skip}'"
fe8809
fe8809
			case "${skip}" in
fe8809
			success) debug "${check} succeeded: ${reason}"; echo 0 ;;
fe8809
			fail)    debug "${check} failed: ${reason}"; echo 1 ;;
fe8809
			skip)    debug "${check} skipped: ${reason}"; echo 2 ;;
fe8809
			*)       debug "${check} error: unexpected skip=" \
fe8809
				       "setting (${skip})"; echo 9 ;;
fe8809
			esac
fe8809
			;;
fe8809
		3)
fe8809
			local reason="result=${result} and force_skip='${force_skip}'"
fe8809
fe8809
			case "${force_skip}" in
fe8809
			success) debug "${check} succeeded: ${reason}"; echo 0 ;;
fe8809
			fail)    debug "${check} failed: ${reason}"; echo 1 ;;
fe8809
			skip)    debug "${check} skipped: ${reason}"; echo 2 ;;
fe8809
			*)       debug "${check} error: unexpected force-skip=" \
fe8809
				       "setting (${skip})"; echo 9 ;;
fe8809
			esac
fe8809
			;;
fe8809
		*)
fe8809
			debug "${check} error: unexpected check_caveat result" \
fe8809
			      "(${result})"; echo 9 ;;
fe8809
		esac
fe8809
		;;
fe8809
	*)
fe8809
		debug "${check} error: unknown dependency type '${dep_type}'"
fe8809
		echo 9
fe8809
		;;
81200a
	esac
81200a
}
81200a
c59b13
# Provides model in format "VENDOR_ID FAMILY-MODEL-STEPPING"
c59b13
#
c59b13
# We check only the first processor as we don't expect non-symmetrical setups
c59b13
# with CPUs with caveats
c59b13
get_model_string()
c59b13
{
c59b13
	/usr/bin/printf "%s %02x-%02x-%02x" \
c59b13
		$(/bin/sed -rn '1,/^$/{
c59b13
			s/^vendor_id[[:space:]]*: (.*)$/\1/p;
c59b13
			s/^cpu family[[:space:]]*: (.*)$/\1/p;
c59b13
			s/^model[[:space:]]*: (.*)$/\1/p;
c59b13
			s/^stepping[[:space:]]*: (.*)$/\1/p;
c59b13
		}' /proc/cpuinfo)
c59b13
}
c59b13
c59b13
get_model_name()
c59b13
{
c59b13
	/bin/sed -rn '1,/^$/s/^model name[[:space:]]*: (.*)$/\1/p' /proc/cpuinfo
c59b13
}
c59b13
c59b13
get_vendor_id()
c59b13
{
c59b13
	/bin/sed -rn '1,/^$/s/^vendor_id[[:space:]]*: (.*)$/\1/p' /proc/cpuinfo
c59b13
}
c59b13
c59b13
get_mc_path()
c59b13
{
c59b13
	case "$1" in
c59b13
	GenuineIntel)
c59b13
		echo "intel-ucode/$2"
c59b13
		;;
c59b13
	AuthenticAMD)
c59b13
		echo "amd-ucode/$2"
c59b13
		;;
fe8809
	*)
fe8809
		# We actually only support Intel ucode, but things may break
fe8809
		# if nothing is printed (input would be gotten from stdin
fe8809
		# otherwise).
fe8809
		echo "invalid"
fe8809
		;;
c59b13
	esac
c59b13
}
c59b13
c59b13
get_mc_ver()
c59b13
{
c59b13
	/bin/sed -rn '1,/^$/s/^microcode[[:space:]]*: (.*)$/\1/p' /proc/cpuinfo
c59b13
}
c59b13
c59b13
c59b13
match_model=0
c59b13
configs=
c59b13
kver=$(/bin/uname -r)
c59b13
verbose=0
c59b13
early_check=0
078ac8
print_disclaimers=0
c59b13
c59b13
ret=0
c59b13
078ac8
while getopts "dek:c:mv" opt; do
c59b13
	case "${opt}" in
078ac8
	d)
078ac8
		print_disclaimers=1
078ac8
		early_check=2
078ac8
		;;
c59b13
	e)
c59b13
		early_check=1
c59b13
		;;
c59b13
	k)
c59b13
		kver="$OPTARG"
c59b13
		;;
c59b13
	c)
c59b13
		configs="$configs $OPTARG"
c59b13
		;;
c59b13
	m)
c59b13
		match_model=1
c59b13
		;;
c59b13
	v)
c59b13
		verbose=1
c59b13
		;;
c59b13
	*)
c59b13
		usage
c59b13
		exit 1;
c59b13
		;;
c59b13
	esac
c59b13
done
c59b13
81200a
: "${configs:=$(find "${MC_CAVEATS_DATA_DIR}" -maxdepth 1 -mindepth 1 -type d -printf "%f\n")}"
c59b13
c59b13
cpu_model=$(get_model_string)
c59b13
cpu_model_name=$(get_model_name)
c59b13
cpu_vendor=$(get_vendor_id)
c59b13
c59b13
ret_paths=""
c59b13
ok_paths=""
c59b13
fail_paths=""
c59b13
c59b13
ret_cfgs=""
c59b13
ok_cfgs=""
c59b13
fail_cfgs=""
c59b13
c59b13
skip_cfgs=""
c59b13
c59b13
if [ 1 -eq "$early_check" ]; then
c59b13
	stage="early"
c59b13
else
c59b13
	stage="late"
c59b13
fi
c59b13
fe8809
# check_caveat CFG [CHECK_LEVEL]
fe8809
# changes ret_paths, ok_paths, fail_paths, ret_cfgs, ok_cfgs, fail_cfgs,
fe8809
# skip_cfgs if CHECK_LEVEL is set to 0 (default).
fe8809
# CHECK_LEVEL is used for recursive configuration dependency checks,
fe8809
# and indicates nesting level.
fe8809
# Return value:
fe8809
#  0 - check is successful
fe8809
#  1 - check has been failed
fe8809
#  2 - configuration has been skipped
fe8809
#  3 - configuration has been skipped due to presence of an override file
fe8809
check_caveat() {
fe8809
	local cfg="$1"
fe8809
	local check_level="${2:-0}"
fe8809
	local dir="$MC_CAVEATS_DATA_DIR/$cfg"
c59b13
c59b13
	[ -r "${dir}/readme" ] || {
c59b13
		debug "File 'readme' in ${dir} is not found, skipping"
fe8809
		return 2
c59b13
	}
c59b13
c59b13
	[ -r "${dir}/config" ] || {
c59b13
		debug "File 'config' in ${dir} is not found, skipping"
fe8809
		return 2
c59b13
	}
c59b13
fe8809
	local cfg_model=
fe8809
	local cfg_vendor=
fe8809
	local cfg_path=
fe8809
	local cfg_kvers=
fe8809
	local cfg_kvers_early=
fe8809
	local cfg_mc_min_ver_late=
fe8809
	local cfg_disable=
fe8809
	local cfg_pci=
fe8809
	local cfg_dmi=
fe8809
	local cfg_dependency=
fe8809
fe8809
	local key
fe8809
	local value
c59b13
c59b13
	while read -r key value; do
c59b13
		case "$key" in
c59b13
		model)
c59b13
			cfg_model="$value"
c59b13
			;;
c59b13
		vendor)
c59b13
			cfg_vendor="$value"
c59b13
			;;
c59b13
		path)
c59b13
			cfg_path="$cfg_path $value"
c59b13
			;;
c59b13
		kernel)
c59b13
			cfg_kvers="$cfg_kvers $value"
c59b13
			;;
c59b13
		kernel_early)
c59b13
			cfg_kvers_early="$cfg_kvers_early $value"
c59b13
			;;
c59b13
		mc_min_ver_late)
c59b13
			cfg_mc_min_ver_late="$value"
c59b13
			;;
c59b13
		disable)
c59b13
			cfg_disable="$cfg_disable $value "
c59b13
			;;
81200a
		pci_config_val)
81200a
			cfg_pci="$cfg_pci
81200a
				$value"
81200a
			;;
81200a
		dmi)
81200a
			cfg_dmi="$cfg_dmi
81200a
				$value"
81200a
			;;
fe8809
		dependency)
fe8809
			cfg_dependency="$cfg_dependency
fe8809
				$value"
fe8809
			;;
81200a
		'#'*|'')
81200a
			continue
81200a
			;;
81200a
		*)
81200a
			debug "Unknown key '$key' (value '$value') in config" \
81200a
			      "'$cfg'"
81200a
			;;
c59b13
		esac
c59b13
	done < "${dir}/config"
c59b13
c59b13
	debug "${cfg}: model '$cfg_model', path '$cfg_path', kvers '$cfg_kvers'"
fe8809
	echo "$cfg_path"
c59b13
c59b13
	# Check for override files in the following order:
c59b13
	#  - disallow early/late specific caveat for specific kernel
c59b13
	#  - force early/late specific caveat for specific kernel
c59b13
	#  - disallow specific caveat for specific kernel
c59b13
	#  - force specific caveat for specific kernel
c59b13
	#
c59b13
	#  - disallow early/late specific caveat for any kernel
c59b13
	#  - disallow early/late any caveat for specific kernel
c59b13
	#  - force early/late specific caveat for any kernel
c59b13
	#  - force early/late any caveat for specific kernel
c59b13
	#  - disallow specific caveat for any kernel
c59b13
	#  - disallow any caveat for specific kernel
c59b13
	#  - force specific caveat for any kernel
c59b13
	#  - force any caveat for specific kernel
c59b13
	#
c59b13
	#  - disallow early/late everything
c59b13
	#  - force early/late everyhting
c59b13
	#  - disallow everything
c59b13
	#  - force everyhting
fe8809
	local ignore_cfg=0
fe8809
	local force_cfg=0
fe8809
	local override_file=""
fe8809
	local overrides="
c59b13
	0:$FW_DIR/$kver/disallow-$stage-$cfg
c59b13
	1:$FW_DIR/$kver/force-$stage-$cfg
c59b13
	0:$FW_DIR/$kver/disallow-$cfg
c59b13
	1:$FW_DIR/$kver/force-$cfg
c59b13
	0:$FW_DIR/$kver/disallow-$stage
c59b13
	0:$CFG_DIR/disallow-$stage-$cfg
c59b13
	1:$FW_DIR/$kver/force-$stage
c59b13
	1:$CFG_DIR/force-$stage-$cfg
c59b13
	0:$FW_DIR/$kver/disallow
c59b13
	0:$CFG_DIR/disallow-$cfg
c59b13
	1:$FW_DIR/$kver/force
c59b13
	1:$CFG_DIR/force-$cfg
c59b13
	0:$CFG_DIR/disallow-$stage
c59b13
	1:$CFG_DIR/force-$stage
c59b13
	0:$CFG_DIR/disallow
c59b13
	1:$CFG_DIR/force"
fe8809
	local o
fe8809
	local o_force
fe8809
	local override_file
c59b13
	for o in $(echo "$overrides"); do
c59b13
		o_force=${o%%:*}
c59b13
		override_file=${o#$o_force:}
c59b13
c59b13
		[ -e "$override_file" ] || continue
c59b13
c59b13
		if [ 0 -eq "$o_force" ]; then
c59b13
			ignore_cfg=1
c59b13
		else
c59b13
			force_cfg=1
c59b13
		fi
c59b13
c59b13
		break
c59b13
	done
c59b13
c59b13
	[ 0 -eq "$ignore_cfg" ] || {
c59b13
		debug "Configuration \"$cfg\" is ignored due to presence of" \
c59b13
		      "\"$override_file\"."
fe8809
		return 3
c59b13
	}
c59b13
c59b13
	# Check model if model filter is enabled
c59b13
	if [ 1 -eq "$match_model" -a  -n "$cfg_model" ]; then
c59b13
		[ "x$cpu_model" = "x$cfg_model" ] || {
c59b13
			debug "Current CPU model '$cpu_model' doesn't" \
c59b13
			      "match configuration CPU model '$cfg_model'," \
c59b13
			      "skipping"
fe8809
			return 2
c59b13
		}
c59b13
	fi
c59b13
c59b13
	# Check paths if model filter is enabled
fe8809
	local cpu_mc_path
fe8809
	local cfg_mc_present
c59b13
	if [ 1 -eq "$match_model" -a  -n "$cfg_path" ]; then
c59b13
		cpu_mc_path="$MC_CAVEATS_DATA_DIR/$cfg/$(get_mc_path \
c59b13
			"$cpu_vendor" "${cpu_model#* }")"
c59b13
		cfg_mc_present=0
c59b13
c59b13
		for p in $(printf "%s" "$cfg_path"); do
c56524
			/usr/bin/find "$MC_CAVEATS_DATA_DIR/$cfg" \
c56524
				-path "$MC_CAVEATS_DATA_DIR/$cfg/$p" -print0 \
c56524
			    | /bin/grep -zFxc "$cpu_mc_path" > /dev/null \
c59b13
			    || continue
c59b13
c59b13
			cfg_mc_present=1
81200a
			break
c59b13
		done
c59b13
c59b13
		[ 1 = "$cfg_mc_present" ] || {
c59b13
			debug "No matching microcode files in '$cfg_path'" \
c59b13
			      "for CPU model '$cpu_model', skipping"
fe8809
			return 2
c59b13
		}
c59b13
	fi
c59b13
c59b13
	# Check vendor if model filter is enabled
c59b13
	if [ 1 -eq "$match_model" -a  -n "$cfg_vendor" ]; then
c59b13
		[ "x$cpu_vendor" = "x$cfg_vendor" ] || {
c59b13
			debug "Current CPU vendor '$cpu_vendor' doesn't" \
c59b13
			      "match configuration CPU vendor '$cfg_vendor'," \
c59b13
			      "skipping"
fe8809
			return 2
c59b13
		}
c59b13
	fi
c59b13
fe8809
	# Has to be performed before dependency checks
c59b13
	[ 0 -eq "$force_cfg" ] || {
c59b13
		debug "Checks for configuration \"$cfg\" are ignored due to" \
c59b13
		      "presence of \"$override_file\"."
c59b13
fe8809
		return 0
c59b13
	}
c59b13
fe8809
	# Check dependencies
fe8809
	# It has to be performed here (before adding configuration
fe8809
	# to $ret_cfgs/$ret_paths) since it may be skipped.
fe8809
	if [ -n "$cfg_dependency" ]; then
fe8809
		dep_line="$(printf "%s\n" "$cfg_dependency" | \
fe8809
			while read -r dep_type dep_name dep_opts
fe8809
			do
fe8809
				[ -n "$dep_type" ] || continue
fe8809
				dep_res=$(check_dependency "$check_level" \
fe8809
							   "$dep_type" \
fe8809
							   "$dep_name" \
fe8809
							   "$dep_opts")
fe8809
				[ 0 != "$dep_res" ] || continue
fe8809
				echo "$dep_res $dep_type $dep_name $dep_opts"
fe8809
				break
fe8809
			done
fe8809
			echo "0 ")"
fe8809
fe8809
		case "${dep_line%% *}" in
fe8809
		0) ;;
fe8809
		2)
fe8809
			debug "Dependency check '${dep_line#* }'" \
fe8809
			      "induced configuration skip"
fe8809
			return 2
fe8809
			;;
fe8809
		*)
fe8809
			debug "Dependency check '${dep_line#* }'" \
fe8809
			      "failed (with return code ${dep_line%% *})"
fe8809
			return 1
fe8809
			;;
fe8809
		esac
fe8809
	fi
fe8809
fe8809
	# Check configuration files
fe8809
c59b13
	[ "x${cfg_disable%%* $stage *}" = "x$cfg_disable" ] || {
c59b13
		debug "${cfg}: caveat is disabled in configuration"
fe8809
		return 1
c59b13
	}
c59b13
c59b13
	# Check late load kernel version
c59b13
	if [ 1 -ne "$early_check" -a -n "$cfg_kvers" ]; then
c59b13
		check_kver "$kver" $cfg_kvers || {
c59b13
			debug "${cfg}: late load kernel version check for" \
c59b13
			      " '$kver' against '$cfg_kvers' failed"
fe8809
			return 1
c59b13
		}
c59b13
	fi
c59b13
c59b13
	# Check early load kernel version
c59b13
	if [ 0 -ne "$early_check" -a -n "$cfg_kvers_early" ]; then
c59b13
		check_kver "$kver" $cfg_kvers_early || {
c59b13
			debug "${cfg}: early load kernel version check for" \
c59b13
			      "'$kver' against '$cfg_kvers_early' failed"
fe8809
			return 1
c59b13
		}
c59b13
	fi
c59b13
c59b13
	# Check current microcode version for the late update
c59b13
	if [ -n "$cfg_mc_min_ver_late" -a 1 -ne "$early_check" -a \
c59b13
	   "x$cpu_model" = "x$cfg_model" ]; then
c59b13
		cpu_mc_ver="$(get_mc_ver)"
c59b13
c59b13
		[ 1 -eq $((cpu_mc_ver >= cfg_mc_min_ver_late)) ] || {
c59b13
			debug "${cfg}: CPU microcode version $cpu_mc_ver" \
c59b13
			      "failed check (should be at least" \
c59b13
			      "${cfg_mc_min_ver_late})"
fe8809
			return 1
c59b13
		}
c59b13
	fi
c59b13
81200a
	# Check PCI devices if model filter is enabled
81200a
	# Note that the model filter check is done inside check_pci_config_val
81200a
	# based on the 'mode=' parameter.
81200a
	if [ -n "$cfg_pci" ]; then
81200a
		pci_line="$(printf "%s\n" "$cfg_pci" | while read -r pci_line; do
81200a
				[ -n "$pci_line" ] || continue
81200a
				pci_res=$(check_pci_config_val "$pci_line" \
81200a
							       "$match_model")
81200a
				[ 0 != "$pci_res" ] || continue
81200a
				echo "$pci_res $pci_line"
81200a
				break
81200a
			done
81200a
			echo "0 ")"
81200a
81200a
		[ -z "${pci_line#* }" ] || {
81200a
			debug "PCI configuration word check '${pci_line#* }'" \
81200a
			      "failed (with return code ${pci_line%% *})"
fe8809
			return 1
81200a
		}
81200a
	fi
81200a
81200a
	# Check DMI data if model filter is enabled
fe8809
	# Note that the model filter check is done inside check_dmi_val
fe8809
	# (which returns the value of 'no-model-mode=' parameter
fe8809
	# if it is disenaged).
81200a
	if [ -n "$cfg_dmi" ]; then
81200a
		dmi_line="$(printf "%s\n" "$cfg_dmi" | while read -r dmi_line
81200a
			do
81200a
				[ -n "$dmi_line" ] || continue
81200a
				dmi_res=$(check_dmi_val "$dmi_line" \
81200a
							"$match_model")
81200a
				[ 0 != "$dmi_res" ] || continue
81200a
				echo "$dmi_res $dmi_line"
81200a
				break
81200a
			done
81200a
			echo "0 ")"
81200a
81200a
		[ -z "${dmi_line#* }" ] || {
81200a
			debug "DMI data check '${dmi_line#* }'" \
81200a
			      "failed (with return code ${dmi_line%% *})"
fe8809
			return 1
81200a
		}
81200a
	fi
81200a
fe8809
	return 0
fe8809
}
fe8809
fe8809
for cfg in $(echo "${configs}"); do
fe8809
	if cfg_path=$(check_caveat "$cfg"; exit "$?")
fe8809
	then
fe8809
		ret_cfgs="$ret_cfgs $cfg"
fe8809
		ret_paths="$ret_paths $cfg_path"
fe8809
		ok_cfgs="$ok_cfgs $cfg"
fe8809
		ok_paths="$ok_paths $cfg_path"
fe8809
	else
fe8809
		case "$?" in
fe8809
		1)
fe8809
			ret=1
fe8809
fe8809
			ret_cfgs="$ret_cfgs $cfg"
fe8809
			ret_paths="$ret_paths $cfg_path"
fe8809
			fail_cfgs="$fail_cfgs $cfg"
fe8809
			fail_paths="$fail_paths $cfg_path"
fe8809
fe8809
			[ 0 -eq "$print_disclaimers" ] \
fe8809
				|| [ ! -e "${MC_CAVEATS_DATA_DIR}/${cfg}/disclaimer" ] \
fe8809
				|| /bin/cat "${MC_CAVEATS_DATA_DIR}/${cfg}/disclaimer"
fe8809
			;;
fe8809
		2|3)
fe8809
			skip_cfgs="$skip_cfgs $cfg";
fe8809
			;;
fe8809
		*)
fe8809
			debug "Unexpected check_caveat return code '$?'" \
fe8809
			      "for config '$cfg'"
fe8809
			;;
fe8809
		esac
fe8809
	fi
c59b13
done
c59b13
078ac8
[ 0 -eq "$print_disclaimers" ] || exit 0
078ac8
c59b13
echo "cfgs$ret_cfgs"
c59b13
echo "skip_cfgs$skip_cfgs"
c59b13
echo "paths$ret_paths"
c59b13
echo "ok_cfgs$ok_cfgs"
c59b13
echo "ok_paths$ok_paths"
c59b13
echo "fail_cfgs$fail_cfgs"
c59b13
echo "fail_paths$fail_paths"
c59b13
c59b13
exit $ret